      SUBROUTINE AZIP(IP,NP,D,LD,IFWA,LEFT,MA,FPD,NUMB,LOCREG,NUMR,MCZ,
     1 NUMBOD,KBZ)
C ** AZIP READS ARRAY GEOMETRY DATA **
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     98/07/09
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     15:29:15
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MAAZIP
C     CURRENT ARCHIVING LEVEL NUMBER:                   00004
C     CURRENT NUMBER OF PERMANENT UPDATES:              00004
C     DATE OF LAST ACCESS BY LIBRARIAN:                 98/07/09
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
      IMPLICIT REAL*8 (A-H,O-Z)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      COMMON/FLAG/IERROR
CTAT
      REAL*4 D
CSHR
      PARAMETER ( ISPCD = 2 )
CSHR
CLNG
C     PARAMETER ( ISPCD = 1 )
CLNG
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON/ARAR/NBY,NLEV,NAR,NQ,IAW,IAY,NF,NX1(3)
      COMMON/JOMK/NBI,IRI,JMK,IML,IOP,IMAX
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      DIMENSION D(*),LD(*),IP(*),MA(*),FPD(*),LOCREG(*),MCZ(*),
     1 NUMBOD(*),KBZ(*)
      ICR=1
      IRET=0
      NAR=0
      NLEV=0
      IP(NP)=IFWA
      NQ=NP
      ID=1
   7  IX=IP(NP)+3*(ID-1)
      LD(IX)=IREAD(ICR,IRET)
      IF(LD(IX).EQ.0) GO TO 14
      LD(IX+1)=IREAD(0,IRET)
      LD(IX+2)=IREAD(0,IRET)
      ICR=0
      ID=ID+1
      GO TO 7
  14  NAR=ID-1
      IF(NAR.LE.0) GO TO 105
      IF(JMK.LE.1) GO TO 15
      IF(IML.EQ.1) GO TO 15
      NAR=2
      ID=ID+1
      LD(IX)=1
      LD(IX+1)=1
      LD(IX+2)=1
  15  CONTINUE
      IP(NP+1)=IP(NP)+NAR
      IP(NP+1)=2*(IP(NP+1)/2)+1
      IP(NP+2)=IP(NP+1)+ISPCD*3*NAR
      IP(NP+3)=IP(NP+2)
      IP(NP+4)=IP(NP+3)+3*NAR
      N3=3*NAR
      DO 16 I=1,N3
      I1=IP(NP)+I-1
      I2=IP(NP+3)+I-1
      LD(I2)=LD(I1)
      LD(I1)=0
  16  CONTINUE
      NMAX=0
      DO 10 I=1,NUMR
      IF(KBZ(I).GT.NMAX) NMAX=KBZ(I)
      IF(MCZ(I).GE.0) GO TO 10
      IF(MCZ(I).EQ.-1000) GO TO 10
      IC=IABS(MCZ(I))
      IZ=IP(NP)+IC-1
      LD(IZ)=1
  10  CONTINUE
C.....ARRAY POINTERS....
C......IP(NP+3) IS THE ARRAY SIZE , NXMAX BY NYMAX BY NZMAX FOR EACH ARR
C.....IP(NP+4) IS THE LOOKUP POINTER FOR ARRAY CELL DEFINITIONS
C.... IP(NP+5) IS THE CELL NAME DEFINITION ARRAY FOR EACH ARRAY
C
      IAW=0
      IAY=1
      DO 30 N=1,NAR
      IND=IP(NP+3)+3*(N-1)
      IAZ=LD(IND)*LD(IND+1)*LD(IND+2)
      IAX=LD(IND)+LD(IND+1)+LD(IND+2)+3
      IDN=IP(NP+4)+N-1
      LD(IDN)=IAZ
      IAY=IAY+IAZ
      IAW=IAW+IAX
  30  CONTINUE
      IP(NP+5)=IP(NP+4)+NAR+1
      IP(NP+6)=IP(NP+5)+IAY-1
      IBOD=1
      ICR=1
      IRET=0
      MM=0
      IOP=IREAD(0,IRET)
      DO 40 N=1,NAR
      IDN=IP(NP+4)+N-1
      IA=LD(IDN)
      IF(JMK.LE.1) GO TO 125
      IF(N.EQ.1) GO TO 125
      IND=IP(NP+5)+MM
      LD(IND)=IMAX
      IF(IMAX.GT.IBOD) IBOD=IMAX
      GO TO 150
 125  CONTINUE
      IF(IOP.EQ.1) GO TO 130
      IF(IOP.EQ.2) GO TO 150
      DO 35 I=1,IA
      IND=IP(NP+5)+MM+I-1
      LD(IND)=IREAD(ICR,IRET)
      ICR=0
      IF(LD(IND).GT.IBOD) IBOD=LD(IND)
  35  CONTINUE
      GO TO 150
 130  CONTINUE
      IC=1
      IZ=IP(NP+3)+3*(N-1)
      NZMAX=LD(IZ+2)
      NYMAX=LD(IZ+1)
      NXMAX=LD(IZ)
      IR=0
 135  CONTINUE
      LCX=IREAD(IC,IR)
      IF(LCX.GT.IBOD) IBOD=LCX
      IC=0
      I1=IREAD(0,IR)
      I2=IREAD(0,IR)
      IS=IREAD(0,IR)
      J1=IREAD(0,IR)
      J2=IREAD(0,IR)
      JS=IREAD(0,IR)
      K1=IREAD(0,IR)
      K2=IREAD(0,IR)
      KS=IREAD(0,IR)
      IF(IS.LE.0 .OR. JS.LE.0 .OR. KS.LE.0) GO TO 136
      IF(I1.LT.1.OR.I1.GT.NXMAX .OR. I2.LT.1.OR. I2.GT.NXMAX)GO TO 136
      IF(J1.LT.1.OR.J1.GT.NYMAX .OR. J2.LT.1.OR. J2.GT.NYMAX)GO TO 136
      IF(K1.LT.1.OR.K1.GT.NZMAX .OR. K2.LT.1.OR. K2.GT.NZMAX)GO TO 136
      GO TO 138
 136  WRITE(IOT, 120)I1,I2,IS,J1,J2,JS,K1,K2,KS
 120  FORMAT('0THERE IS AN ERROR IN THE ARRAY DATA FOR LOOP INDICES'
     * ,' WHEN IOP=1', /
     1  '0**FOR I',3I5,5X,'FOR J',3I5,5X,'FOR K',3I5)
CHANGED BY ST 96/12/18
C     STOP
      CALL ERRTRA
      RETURN
 138  DO 140 K=K1,K2,KS
      DO 140 J=J1,J2,JS
      DO 140 I=I1,I2,IS
      IND=NYMAX*NXMAX*(K-1)+NXMAX*(J-1)+I+IP(NP+5)-1+MM
      LD(IND)=LCX
 140  CONTINUE
      IFLAG=IREAD(0,IR)
      IF(IFLAG.EQ.0) GO TO 135
 150  CONTINUE
      LD(IDN)=IP(NP+5)+MM
      MM=MM+IA
  40  CONTINUE
      LD(IDN+1)=IP(NP+5)+MM
      IF(IOP.NE.2) GO TO 55
      IH=IP(NP+4)
      IH1=-99
      IH2=1
      IBOD=NMAX
      CALL FIDAS(D,D,LD(IH),IH1,IH2,INTT,IOT)
  55  CONTINUE
      DO 200 N=1,NAR
      IZ=IP(NP+3)+3*(N-1)
      NZMAX=LD(IZ+2)
      NYMAX=LD(IZ+1)
      NXMAX=LD(IZ)
      WRITE(IOT,185) N,NXMAX,NYMAX,NZMAX
      IF(IBOD.LE.1) GO TO 200
 185  FORMAT(1H1,15X,'ARRAY NO.',I5,5X,'ARRAY SIZE IS',I5,' BY',
     1 I5,' BY',I5   )
 187  FORMAT(6X,'X =',1X,30I3)
 188  FORMAT(4X,'Y'  )
      IDN=IP(NP+4)+N-1
      MM=LD(IDN)
      DO 172 K=1,NZMAX
      M1=1
      M2=30
 160  CONTINUE
      IF(M2.GT.NXMAX) M2=NXMAX
      WRITE(IOT,175) K,N
      WRITE(IOT,187) (I,I=M1,M2)
      WRITE(IOT,188)
      DO 170 JX=1,NYMAX
      J=NYMAX-JX+1
      IND=NYMAX*NXMAX*(K-1)+NXMAX*(J-1)-1+MM
      WRITE(IOT,180) J,(LD(IND+I),I=M1,M2)
 170  CONTINUE
      IF(M2.GE.NXMAX) GO TO 172
      M1=M1+30
      M2=M2+30
      GO TO 160
 172  CONTINUE
 200  CONTINUE
 175  FORMAT( //,15X,' LEVEL ',I5,' OF ARRAY NO. ',I5,/  )
 180  FORMAT(/,I5,5X,30I3,3(/,10X,30I3))
      IP(NP+7)=IP(NP+6)+IBOD
      DO 48 I=1,IBOD
      DO 46 L=1,NUMR
      IF(KBZ(L).NE.I) GO TO 46
      IF(MCZ(L).NE.-1000) GO TO 46
      N=LOCREG(L)+1
      NUM=NUMBOD(L)*5+N-5
      DO 45 J=N,NUM,5
      NBY=MA(J)
      IF(NBY.GT.0) GO TO 45
      IX=IP(NP+6)+I-1
      LD(IX)=IABS(NBY)
      GO TO 48
  45  CONTINUE
  46  CONTINUE
      WRITE(IOT,52) I
  52  FORMAT(//,10X,'FATAL ERROR - UNIVERSE NO.',I5,' IS NOT DEFINED')
CHANGED BY ST 96/12/18
C     STOP
      CALL ERRTRA
      RETURN
  48  CONTINUE
      IP(NP+8)=IP(NP+7)+3*NAR
      IP(NP+8)=2*(IP(NP+8)/2)+1
      I0=IP(NP)
      I3=IP(NP+3)
      I4=IP(NP+4)
      I6=IP(NP+6)
      CALL LEVEL(D(I0),D(I3),D(I4),D(I6),D,D,KBZ,MCZ,NUMR)
      IND=IP(NP+8)
      I1=IP(NP+1)
      DO 64 LV=1,NLEV
      L=NLEV-LV+1
      DO 60 N=1,NAR
      IX=IP(NP)+N-1
      IDX=IP(NP+7)+3*(N-1)
      IF(LD(IX).LE.0) LD(IDX)=0
      IF(LD(IX).NE.L) GO TO 60
      I3=IP(NP+3)+3*(N-1)
      I4=IP(NP+4)+N-1
      I5=LD(I4)
      I6=IP(NP+6)
      IAX=LD(I3)+LD(I3+1)+LD(I3+2)+3
      LD(IDX)=IND
      LD(IDX+1)=LD(IDX)+ISPCD*(LD(I3)+1)
      LD(IDX+2)=LD(IDX+1)+ISPCD*(LD(I3+1)+1)
      CALL ARGEN(D,D,LD(I3),LD(I5),LD(I6),LD(IND),MA,FPD,D(I1),N)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      IND=IND+ISPCD*IAX
  60  CONTINUE
  64  CONTINUE
      IP(NP+9)=IND
      IP(NP+10)=IP(NP+9)+NUMB
      IP(NP+10)=ISPCD*(IP(NP+10)/ISPCD)+1
      NF=IP(NP+10)
      DO 95 NBY=1,NUMB
      L=IP(NP+9)+NBY-1
      LD(L)=0
      KM=7*(NBY-1)+1
      IF(MA(KM+2).NE.7) GO TO 95
      DO 80 IB=1,NUMR
      IF(MCZ(IB).GE.0) GO TO 80
      IF(MCZ(IB).EQ.-1000) GO TO 80
      IA=LOCREG(IB)
      IF(NBY.EQ.MA(IA+1)) GO TO 87
  80  CONTINUE
      DO 85 IB=1,IBOD
      II=IP(NP+6)+IB-1
      IF(NBY.EQ.LD(II)) GO TO 87
  85  CONTINUE
      GO TO 95
  87  CONTINUE
      LD(L)=NF
      CALL ORTHOM(D,D,MA,FPD,NBY,D(NF))
      NF=NF+ISPCD*9
  95  CONTINUE
      IP(NP+11)=NF
      IP(NP+12)=IP(NP+11)+6*NLEV+4
      LT=IP(NP+11)
      LU=LT+6*NLEV+4
      DO 100 I=LT,LU
      LD(I)=0
 100  CONTINUE
      I3=IP(NP+3)
      I4=IP(NP+4)
      I6=IP(NP+6)
      I1=IP(NP+1)
      I7=IP(NP+7)
      CALL FINEFI(LD(I3),LD(I4),LD(I6),LD(I7),D(I1),MA,FPD,NUMBOD,
     1 LOCREG,KBZ,MCZ,D,LD,IP,IBOD,NUMR)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      GO TO 108
 105  CONTINUE
      DO 106 I=1,11
      IP(NP+I)=IP(NP+I-1)
 106  CONTINUE
      IP(NP+12)=IP(NP+11)+6*NLEV+4
      IBOD=0
 108  CONTINUE
      IP(NP+13)=IP(NP+12)+NAR+1
      IP(NP+14)=IP(NP+13)+ISPCD*IBOD+2
      MUS=IP(NP+14)
      MUZ=MUS
      IFLOW=0
      IF(IBOD.LE.0) GO TO 109
      CALL UNIS(NP,IP,D,D,MA,FPD,LOCREG,NUMR,MCZ,KBZ,IBOD,NUMBOD)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
 109  CONTINUE
      IP(NP+15)=IP(NP+14)
      IF(NAR.GE.1) IP(NP+15)=IP(NP+14)+6*NLEV+4
      NP=NP+15
      IIT=IP(NP)-IP(NQ)+1
      LEFT=LEFT-IIT
      WRITE(IOT,110) IIT,LEFT
 110  FORMAT(//,' ARRAY DATA REQUIRES',I10,' LOCATIONS, LEAVING',
     1 I10,' LOCATIONS',//)
      L1=0
      IAW=IBOD
      IF(NAR.LE.0) RETURN
COFF  CALL DIPR(D,IP,L1)
COFF  CALL PR(D,1)
      RETURN
      END
