      SUBROUTINE GTVLIN(FPD,MRIZ,VNOR,IVOPT,NIR,NIZ,I1,I0)
C **  THIS ROUTINE READS OR CALCULATES VOLUMES OF EACH REGION IN GEOM
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FPD(*),MRIZ(*),VNOR(*)
C     ASSUMES THERE ARE NIR REGIONS
C     I1 IS INPUT TAPE
C     I0 IS OUTPUT TAPE
C     IVOPT IS OPTION FOR CALCULATING VOLUMES
C     IVOPT = 0  SET VOLUME = 1
C     IVOPT = 1  CONCENTRIC SPHERES
C     IVOPT = 2  SLABS
C     IVOPT = 3  READ IN VOLUMES
      WRITE(I0,1001) IVOPT,NIR
 1001 FORMAT(1H1,7H OPTION,I2,37H WAS USED IN CALCULATING VOLUMES, FOR ,
     1 I3,8H REGIONS,/,68H 0-SET VOLUMES = 1, 1-CONCENTRIC SPHERES, 2-SL
     2ABS, 3-INPUTVOLUMES.                      )
      IV=IVOPT+1
      GO TO(500,200,400,100),IV
  100 READ(I1     )(VNOR(I),I=1,NIR)
 1002 FORMAT(7E10.5)
      GO TO 700
  500 DO 50 I=1,NIR
   50 VNOR(I)=1.0
      GO TO 700
C   CON=4*PI/3
  200 CON=4.18879
      J=1
      VOLS=0.0
      DO 250 I=1,NIZ
      IF(I.EQ.NIZ) GO TO 225
      IF(MRIZ(I).EQ.MRIZ(I+1)) GO TO 250
C BUG FIXED ???? AT SCALE-4.3 MARSLIB
C 225 JS=(I-1)*8+6
  225 JS=(I-1)*6+6
      VOLB=CON*FPD(JS)**3
      VNOR(J)=VOLB-VOLS
      VOLS=VOLB
      J=J+1
  250 CONTINUE
      JF=J-1
      IF(JF.EQ.NIR) GO TO 700
      WRITE(I0,1250) JF,NIR
 1250 FORMAT(48H0**********ERROR IN VOLUME CALCULATION**********/
     1   10H      JF =,I3,10H     NIR =,I3      )
CHANGED BY ST 96/12/18
C     STOP
      CALL ERRTRA
      RETURN
 400  CONTINUE
  600 CONTINUE
  700 WRITE(I0,1070)
 1070 FORMAT(1H ,//,10X,71H VOLUMES ( CC ) USED IN COLLISIONS DENSITY AN
     1D TRACK LENGTH ESTIMATORS.    )
      ILN=(NIR-1)/10
      JS=-9
 701  JS=JS+10
      JF=JS+9
      IF(JF.GT.NIR) JF=NIR
      ILN=ILN-1
      WRITE(I0,1071) (J,J=JS,JF)
 1071  FORMAT(1H ,6H   REG , 10(3X,I5,4X))
      WRITE(I0,1072)(VNOR(J),J=JS,JF)
 1072 FORMAT(7H VOLUME,10(1X,1PE10.3,1X)/)
      IF(ILN.GE.0) GO TO 701
      RETURN
      END
