      LOGICAL FUNCTION LREAD ( IZ, IR )
C
C     LREAD RETURNS THE VALUE TRUE IF THE NEXT CHARACTER ON THE
C     CARD IS A NUMBER, OTHERWISE IT RETURNS FALSE.
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     94/11/28
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     15:24:41
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7LREAD
C     CURRENT ARCHIVING LEVEL NUMBER:                   00010
C     CURRENT NUMBER OF PERMANENT UPDATES:              00010
C     DATE OF LAST ACCESS BY LIBRARIAN:                 94/11/28
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
      CHARACTER*1 TEST
C
C
      COMMON /UNIT/ INPT, OUTPT, IDUM(19)
      COMMON /QRDBUF/ UNIT, TENS, DNUM, ICHR, LCHR, IRPT,
     *  WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
      COMMON /YRDBUF/ CHAR, CARD
      SAVE /UNIT/, /QRDBUF/, /YRDBUF/
C
      INTEGER INPT, OUTPT
      DOUBLE PRECISION DNUM, UNIT, TENS, TEN
      CHARACTER*1 CARD, CHAR, BLANK, E, D, COMMA
      LOGICAL WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
C
      DIMENSION CARD(252), CHAR(28)
      DIMENSION UNIT(10), TENS(8)
C
      EQUIVALENCE (D,CHAR(14)), (E,CHAR(15)), (BLANK,CHAR(17))
      EQUIVALENCE (COMMA,CHAR(18)), (TEN,UNIT(2))
C
C
C     CHAR(01) = 1H0
C     CHAR(10) = 1H9
C     CHAR(23) = 1H+
C     CHAR(24) = 1H-
C     CHAR(26) = 1H.
C
      IF ( IRPT.GT.0 ) THEN
C       IF IRPT > 0 THEN THERE IS A REPEATED NUMBER TO BE RETURNED
        LREAD = .TRUE.
        RETURN
      END IF
C
CTAT/MOD(97/OCT) TO AVOID SUDDEN DEATH ---------------------------(FROM)
C     IF ( IR.EQ.2 ) CALL ENFILE
C
      IF ( IR.EQ.2 ) THEN
           CALL ENFILE
           LREAD = .FALSE.
           RETURN
      ENDIF
CTAT/MOD(97/OCT) TO AVOID SUDDEN DEATH ---------------------------( TO )
C
      II     = ICHR
  100 CONTINUE
      IF ( II.GE.LCHR ) THEN
        CALL Y0READ ( CARD, LCHR, IR )
        ICHR   = 0
        IF ( IR.NE.0 ) THEN
          LREAD  = .FALSE.
          RETURN
        END IF
        II     = ICHR
      END IF
      II    = II + 1
      TEST  = CARD(II)
      IF ( TEST.EQ.BLANK ) GO TO 100
      LREAD = TEST.GE.CHAR(01) .AND. TEST.LE.CHAR(10)
      LREAD = LREAD .OR.
     *        TEST.EQ.CHAR(23) .OR.
     *        TEST.EQ.CHAR(24) .OR.
     *        TEST.EQ.CHAR(26)
      RETURN
      END
