      SUBROUTINE NORML(MA,FPD,LOCREG,NUMBOD,IR1,IR2)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     92/06/22
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     08:57:32
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MANORML
C     CURRENT ARCHIVING LEVEL NUMBER:                   00002
C     CURRENT NUMBER OF PERMANENT UPDATES:              00002
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/03/15
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C      THIS ROUTINE CALCULATES THE UNIT VECTOR TO COMBGEOM BODY NASC
C      *    *       *       *    AT POINT XB+WB*DIST    *    *     *
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION MA(*),FPD(*),LOCREG(*),NUMBOD(*) ,IR1(*),IR2(*)
      DIMENSION P(3),F1(3),F2(3)
      COMMON/NORMAL/UN(3)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
      REAL*8 XB,WB,WP,XP,RIN,ROUT,PINF,DIST
      COMMON/PAREM/XB(3),WB(3),WP(3),XP(3),RIN,ROUT,PINF,DIST,IR,IDBG ,
     1             IRPRIM,NASC,LSURF,NBO,LRI,LRO,KLOOP,LOOP,ITYPE,NOA
      DIMENSION X(3),H(3),IBOX1(3),IBOX2(3)
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      DATA IBOX1/10,7,4/
      DATA IBOX2 /4,10,7/
C
C  USER BEWARE       IT IS ASSUMED THAT
C      XB+WB*DIST  IS ON SURFACE LSURF OF BODY NASC.THUS A NORMAL CALL
C      MUST BE PROCEEDED BY A CALL TO G1 OR LOOKZ.
C
      LSUR=IABS(LSURF)
      DO 25 I=1,3
   25 XP(I)=XB(I)+DIST*WB(I)
      JR1= IR1(IR)
      JR2= IR2(IR)
      DO 52 IRR=JR1,JR2
      N=LOCREG(IRR)+1
      NUM=NUMBOD(IRR)*5+N-5
      DO 50 I=N,NUM,5
      IF(NASC.EQ.IABS(MA(I)))   GO TO 100
   50 CONTINUE
  52  CONTINUE
      WRITE(IOT,1000) IR,NASC,(MA(I),I=N,NUM,5)
 1000 FORMAT(40H1INVALID REGION OR BODY IN NORMAL.   IR=,I7,5HNASC=,I7,
     .  /(10I7))
      IADR = 2-KMA
      CALL ABEND(MA(IADR))
CADDED BY ST 96/12/18
      RETURN
  100 L=MA(I+1)
      ITYPE=MA(L+2)
      K=MA(L+6)
C*MIT******* '91/4/25
C            ARB  SPH  RCC  REC  TRC  ELL  BOX  WED  RPP
      GO TO (1100,1200,1400,1400,1400,1600,1700,1800,1900,
CTAT 1998/2/26 BY H.ROW.TATEISHI---FROM
CTAT         GEL  TOR  QUA
CTAT :       2100,1400,1400),ITYPE
C
C            GEL  TOR  QUA  BPP  WPP  P    PX   PY   PZ   PS 
     :       2100,1400,1400,9999,9999,3000,3100,3200,3300,3400,
C            C    CX   CY   CZ
     :       4000,4100,4200,4300),ITYPE
CTAT 1998/2/26 BY H.ROW.TATEISHI---TO
C*MIT*******
C  ARB
 1100 I=K+1+4*(LSUR -1)
      DO 1110 J=1,3
 1110 UN(J)=FPD(I+J)
      GO TO 5000
C  SPH
 1200 DO 1210 I=1,3
 1210 UN(I)=(XP(I)-FPD(K+1+I))/FPD(K+5)
      GO TO 5000
C
C  TRC,RCC AND REC
C
CTAT 1998/2/26 BY H.ROW.TATEISHI---FROM
C1400 H2=0.0D0
CTAT
 1400 CONTINUE
C
C PROCESS FOR TOR & QUA
      IF(ITYPE.EQ.11.OR.ITYPE.EQ.12) THEN
         DO 1401 I=1,3
1401     UN(I)=WB(I)
         GOTO 5000
      ENDIF
C
      H2=0.0D0
CTAT 1998/2/26 BY H.ROW.TATEISHI---TO
      DO 1410 I=1,3
      H(I)=FPD(K+4+I)
 1410 H2=H2+H(I)**2
      GO TO (1415,1415,1435), LSUR
 1415 H2=DSQRT(H2)
      DO 1420 I=1,3
 1420 UN(I)=H(I)/H2
      GO TO 5000
 1435 DO 1440 I=1,3
 1440 X(I)=XP(I)-FPD(K+1+I)
      XMU=0.0D0
      A2=0.0D0
      DO 1445 I=1,3
      J=MOD(I,3)+1
      A2=A2+(H(I)*X(J)-H(J)*X(I))**2
 1445 XMU=XMU+FPD(K+4+I)*X(I)
      IF(ITYPE.EQ.4) GO TO 1300
      R=FPD(K+8)-FPD(K+9)
      IF(ITYPE.EQ.3) R=0.0D0
      B1=R/DSQRT(H2*(H2+R**2))
      B2=1.0D0/DSQRT(A2*(H2+R**2))
      DO 1450 I=1,3
 1450 UN(I)=B2*(X(I)*H2-H(I)*XMU)+B1*H(I)
      GO TO 5000
C
C   THE FOLLOWING CODING IS FOR  SURFACE 3 OF THE REC *****
 1300 ADA=0.0D0
      BDB=0.0D0
      DO 1305 I=1,3
      ADA=ADA+FPD(K+7+I)**2
 1305 BDB=BDB+FPD(K+10+I)**2
      C = DSQRT(ADA-BDB)
C  C IS THE FOCUS LENGTH  ****
      A=DSQRT(ADA)
      DO 1310 I=1,3
 1310 P(I) = C*FPD(K+7+I)/A
      TWOA=A+A
      E=0.0D0
      DO 1315 I=1,3
      TEMP=FPD(K+1+I)+H(I)*XMU/H2
      F1(I) =TEMP+P(I)
      F2(I) =TEMP-P(I)
 1315 E=E+(XP(I)-F1(I))**2
      E=DSQRT(E)
      E1= 0.0D0
      DO 1320 I=1,3
      P(I) = F1(I)+TWOA*(XP(I)-F1(I))/E
 1320 E1= (F2(I)-P(I))**2+E1
      E1= DSQRT(E1)
      DO 1325 I=1,3
 1325 UN(I) = (F2(I)-P(I))/E1
      GO TO 5000
C
C  ELL
 1600 DX=0.0D0
      AN=0.0D0
      C2=FPD(K+8)**2/4.0D0
      DO 1620 I=1,3
      IA=I+K+1
      X(I)=XP(I)-.5*(FPD(IA)+FPD(IA+3))
      H(I)=.5*(FPD(IA+3)-FPD(IA))
 1620 DX=DX+X(I)*H(I)
      DO 1630 I=1,3
      UN(I)=C2*X(I)-DX*H(I)
 1630 AN=AN+UN(I)**2
      IF(AN.LT.1.0D-12) GO TO 999
      AN=DSQRT(AN)
      DO 1635 I=1,3
 1635 UN(I)=UN(I)/AN
      GO TO 5000
  999 WRITE(IOT,1002) NBO,LSURF,(XP(I),I=1,3)
 1002 FORMAT(31H ROUND-OFF ERROR IN NORMAL NBO=,I5,6HLSURF=,I5,3HXP=,
     1     3D12.5)
      IADR = 2-KMA
      CALL ABEND(MA(IADR))
      RETURN
C
C  BOX
 1700 L= 1+(LSUR-1)/2
      I1=IBOX1(L)
      I2=IBOX2(L)
      DO 1720 I=1,3
      X(I)=FPD(K+I1+I)
 1720 H(I)=FPD(K+I2+I)
 1721 AN=0.0D0
      DO 1730 I=1,3
      J=MOD(I,3)+1
      JJ=MOD(I+1,3)+1
      UN(I)=X(J)*H(JJ)-X(JJ)*H(J)
 1730 AN=AN+UN(I)**2
      IF(AN.LT.1.0D-12) GO TO 999
      AN=DSQRT(AN)
      DO 1735 I=1,3
 1735 UN(I)=UN(I)/AN
      GO TO 5000
C
C WED OR RAW
 1800 IF(LSUR .NE.2) GO TO 1700
      DO 1810 I=1,3
      X(I) = FPD(K+10+I)
 1810 H(I)= FPD(K+4+I)-FPD(K+7+I)
      GO TO 1721
C
C  RPP
 1900 DO 1905 I=1,3
 1905 UN(I)=0.0D0
      GO TO (1910,1910,1920,1920,1930,1930), LSUR
 1910 UN(2)=1.0D0
      GO TO 5000
 1920 UN(1)=1.0D0
      GO TO 5000
 1930 UN(3)=1.0D0
      GO TO 5000
C
C  GEL
CTAT 1998/2/26 BY H.ROW.TATEISHI---FROM
C2100 DO 2110 I=1,3
C2110 UN(I)=(XP(I)-FPD(K+1+I))/FPD(K+5)
CTAT
2100  CONTINUE
      DO 2110 I=1,3
2110  UN(I)=WB(I)
CTAT 1998/2/26 BY H.ROW.TATEISHI---TO
      GO TO 5000
C
CTAT 1998/2/26 BY H.ROW.TATEISHI---FROM
C
C    P
3000  CONTINUE
      DO 3001 I=1,3
3001  UN(I)=FPD(K+1+I)
      AN=0.
      DO 3002 I=1,3
3002  AN=AN+UN(I)**2.
      IF(AN.LT.1.0D-12) GO TO 999
      AN=DSQRT(AN)
      DO 3003 I=1,3
3003  UN(I)=UN(I)/AN
      GOTO 5000
C
C   PX
C   PY
C   PZ
3100  CONTINUE
3200  CONTINUE
3300  CONTINUE
      DO 3301 I=1,3
3301  UN(I)=0.
      IF(ITYPE.EQ.16) UN(1)=1.
      IF(ITYPE.EQ.17) UN(2)=1.
      IF(ITYPE.EQ.18) UN(3)=1.
      GOTO 5000
C
C  PS
3400  CONTINUE
      DO 3401 I=1,3
3401  UN(I)=FPD(K+4+I)
      AN=0.
      DO 3402 I=1,3
3402  AN=AN+UN(I)**2.
      IF(AN.LT.1.0D-12) GO TO 999
      AN=DSQRT(AN)
      DO 3403 I=1,3
3403  UN(I)=UN(I)/AN
      GOTO 5000
C
C   C
4000  CONTINUE
      DO 4001 I=1,3
      X(I)=FPD(K+1+I)
4001  H(I)=FPD(K+4+I)
      T=(H(1)*XP(1)+H(2)*XP(2)+H(3)*XP(3)
     1 -(H(1)*X (1)+H(2)*X (2)+H(3)*X (3)))
     1 /(H(1)**2.  +H(2)**2.  +H(3)**2.)
      DO 4002 I=1,3
4002  UN(I)=XP(I)-(X(I)+T*H(I))
      DO 4004 I=1,3
4004  UN(I)=UN(I)/FPD(K+8)
      GOTO 5000
C
C  CX
C  CY
C  CZ
4100  CONTINUE
4200  CONTINUE
4300  CONTINUE
      UN(1)=XP(1)-FPD(K+2)
      UN(2)=XP(2)-FPD(K+3)
      UN(3)=XP(3)-FPD(K+4)
      IF(ITYPE.EQ.21) UN(1)=0.
      IF(ITYPE.EQ.22) UN(2)=0.
      IF(ITYPE.EQ.23) UN(3)=0.
      DO 4302 I=1,3
4302  UN(I)=UN(I)/FPD(K+5)
      GOTO 5000
CTAT 1998/2/26 BY H.ROW.TATEISHI---TO
C
C
C
 5000 XMU=0.0D0
      DO 5005 I=1,3
 5005 XMU=XMU+WB(I)*UN(I)
      AN=DSIGN(1.0D0,-XMU)
      DO 5010 I=1,3
 5010 UN(I)=AN*UN(I)
CTAT 1998/2/26 BY H.ROW.TATEISHI---FROM
 9999 CONTINUE
CTAT 1998/2/26 BY H.ROW.TATEISHI---TO
      RETURN
      END
