      SUBROUTINE SCANON
C
C  SCANON SETS THE READING MODE TO SCAN AHEAD FOR END
C  SCANOF TURNS OFF THE SCAN AHEAD READING MODE
C
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     94/11/28
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     15:25:49
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7SCANON
C     CURRENT ARCHIVING LEVEL NUMBER:                   00006
C     CURRENT NUMBER OF PERMANENT UPDATES:              00006
C     DATE OF LAST ACCESS BY LIBRARIAN:                 94/11/28
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C
      COMMON /UNIT/ INPT, OUTPT, IDUM(19)
      COMMON /QRDBUF/ UNIT, TENS, DNUM, ICHR, LCHR, IRPT,
     *  WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
      COMMON /YRDBUF/ CHAR, CARD
      SAVE /UNIT/, /QRDBUF/, /YRDBUF/
C
      INTEGER INPT, OUTPT
      DOUBLE PRECISION DNUM, UNIT, TENS, TEN
      CHARACTER*1 CARD, CHAR, BLANK, E, D, COMMA
      LOGICAL WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
C
      DIMENSION CARD(252), CHAR(28)
      DIMENSION UNIT(10), TENS(8)
C
      EQUIVALENCE (D,CHAR(14)), (E,CHAR(15)), (BLANK,CHAR(17))
      EQUIVALENCE (COMMA,CHAR(18)), (TEN,UNIT(2))
C
      LSCAN=.TRUE.
      RETURN
C
C     ENTRY SCANOF
C
C     LSCAN = .FALSE.
C     RETURN
C
      ENTRY ALLOWC
C
      LALLC = .TRUE.
      RETURN
C
      ENTRY RESETC
C
      LALLC = .FALSE.
      RETURN
C
      ENTRY RSTPTR(I)
C
      ICHR = I
      RETURN
C
      ENTRY GETPTR(I)
      I = ICHR
      RETURN
C
      ENTRY SETBIN
C
      LBIN = .TRUE.
      RETURN
C
      ENTRY RESETB
C
      LBIN = .FALSE.
      RETURN
C
      ENTRY IONUMS ( NIN, NOU, MIN, MOU )
C
      MIN = INPT
      MOU = OUTPT
      IF (NIN.GT.0) INPT = NIN
      IF (NOU.GT.0) OUTPT = NOU
      RETURN
C
      ENTRY RCRDLN ( LEN,LNSV )
C
      LNSV = LCHR
      LCHR = LEN
      RETURN
      END
