      SUBROUTINE YREAD ( DD, LD, LIM, IT, LERR, IRET)
C
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     96/12/11
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     10:19:36
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7YREAD
C     CURRENT ARCHIVING LEVEL NUMBER:                   00013
C     CURRENT NUMBER OF PERMANENT UPDATES:              00013
C     DATE OF LAST ACCESS BY LIBRARIAN:                 96/12/11
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C
      COMMON /UNIT/ INPT, OUTPT, IDUM(19)
      COMMON /QRDBUF/ UNIT, TENS, DNUM, ICHR, LCHR, IRPT,
     *  WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
      COMMON /YRDBUF/ CHAR, CARD
      SAVE /UNIT/, /QRDBUF/, /YRDBUF/
C
      INTEGER INPT, OUTPT
      DOUBLE PRECISION DNUM, UNIT, TENS, TEN
      CHARACTER*1 CARD, CHAR, BLANK, E, D, COMMA
      LOGICAL WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
C
      DIMENSION CARD(252), CHAR(28)
      DIMENSION UNIT(10), TENS(8)
C
      EQUIVALENCE (D,CHAR(14)), (E,CHAR(15)), (BLANK,CHAR(17))
      EQUIVALENCE (COMMA,CHAR(18)), (TEN,UNIT(2))
C
      DOUBLE PRECISION VNUM, VSTOR, DEL, VL, DREAD
      CHARACTER*1 C,BB,FL,AD,TT,SK,HI,QS,SM,GL,BK,CM
      CHARACTER*4 AREAD
      LOGICAL LSAVE, LERR, LSALL
      DIMENSION DD(LIM), LD(LIM)
      DIMENSION VN(2), VS(2)
      EQUIVALENCE (VNUM,VN(1)),(VLOW,VN(2)),(VSTOR,VS(1)),(VSLOW,VS(2))
      EQUIVALENCE (BB,CHAR(17)),(CM,CHAR(18))
      EQUIVALENCE (FL,CHAR(16)),(AD,CHAR(11))
C
C     DATA STATEMENTS
C
      DATA TT/'T'/, SK/'S'/, HI/'I'/, QS/'Q'/, SM/'N'/, GL/'L'/, BK/'B'/
C
C     END OF SPECIFICATION STATEMENTS
C
C
      LERR   = .FALSE.
      LSAVE  = LSCAN
      LSALL  = LALLC
      LSCAN  = .TRUE.
      LALLC  = .TRUE.
      M1     = -1
      IRET   = 0
      IZ     = 0
      IARD   = 0
      MULT   = MAX0(1,IT)
      LLIM   = MULT*LIM
      I      = 1
  100 CONTINUE
      IF ( IRET.NE.0 )  GO TO 270
      VNUM   = DREAD(IZ,IRET)
      C      = AREAD(M1,IARD)
  110 CONTINUE
      IF (C.EQ.TT)      GO TO 270
      IF (C.EQ.BB .OR. C.EQ.CM) THEN
C     NO MODIFICATION
        IF (I.GT.LLIM) THEN
          LERR   = .TRUE.
          WRITE(OUTPT,10000)
        ELSE
          DD(I)  = VNUM
          IF (IT.EQ.0) LD(I)  = VNUM
          I      = I+1
          IF (IT.EQ.2) THEN
            DD(I)  = VLOW
            I      = I+1
          END IF
        END IF
      ELSE
        IN     = VNUM
        IF (C.EQ.SK) THEN
C     SKIP
          I      = I+IN*MULT
          IF (I.LE.0 .OR. I.GT.LLIM) THEN
            WRITE(OUTPT,10100) IN,I
            LERR   = .TRUE.
CST         I      = MAX(1,MIN(I,LLIM-(MULT-1)))
            I      = MAX0(1,MIN0(I,LLIM-(MULT-1)))
          END IF
        ELSE
          VNUM   = DREAD(IZ,IRET)
          IF (C.EQ.AD) THEN
C     ADDRESS MODIFICATION
            NN     = VNUM
            I      = NN*MULT
            IF (I.LE.0 .OR. I.GT.LLIM) THEN
              WRITE(OUTPT,10200) NN
              LERR   = .TRUE.
CST           I      = MAX(1,MIN(I,LLIM-(MULT-1)))
              I      = MAX0(1,MIN0(I,LLIM-(MULT-1)))
            END IF
          ELSE IF (C.EQ.FL) THEN
C     FILL ARRAY
  150       CONTINUE
            IF (I.GT.LLIM) GO TO 100
            DD(I)  = VNUM
            IF (IT.EQ.0) LD(I)  = VNUM
            I      = I+1
            IF (IT.EQ.2) THEN
              DD(I)  = VLOW
              I      = I+1
            END IF
            GO TO 150
          ELSE IF (C.EQ.QS .OR. C.EQ.SM .OR. C.EQ.BK) THEN
C     SEQUENCE REPEAT
            IL     = VNUM*MULT
CST         IN     = MAX(IN,1)
            IN     = MAX0(IN,1)
            IB     = 0
C     B IS A REVERSE REPEAT OF IL ENTRIES WITH A BACKSPACE OF IN
            IF (C.EQ.BK) THEN
              IB     = IN*MULT
              IN     = 1
            ENDIF
            IF (I-IL-IB.LE.0) THEN
              WRITE(OUTPT,10300) C,IL,I,IB
              LERR   = .TRUE.
            ELSE IF (I-1+IL*IN.GT.LLIM) THEN
              WRITE(OUTPT,10400) C,IL,I,IB,IN
              LERR   = .TRUE.
            ELSE
              DO 180 LSQ=1,IN
                DO 170 II=1,IL
C     Q IS A REPEAT OF IL ENTRIES
                  IF (C.EQ.QS) THEN
                    J      = I - IL
C     N IS A REVERSE REPEAT OF IL ENTRIES
                  ELSE
                    J      = I - (2*II-1) - IB
                  END IF
                  DD(I)  = DD(J)
                  I      = I+1
                  IF (IT.EQ.2) THEN
                    DD(I)  = DD(J+1)
                    I      = I+1
                  END IF
  170             CONTINUE
  180           CONTINUE
            END IF
          ELSE IF (C.EQ.GL) THEN
C     LOGARITHMIC INTERPOLATION
            L      = IN+1
            VL     = L
            VSTOR  = VNUM
            VNUM   = DREAD(IZ,IRET)
            C      = AREAD(M1,IARD)
            IF (C.NE.BB .AND. C.NE.CM) THEN
              IN     = VNUM
              VNUM   = DREAD(IZ,IRET)
            END IF
            IF (I+L*MULT.GT.LLIM) THEN
              WRITE(OUTPT,10500) GL,IN
              LERR   = .TRUE.
            ELSE
              DEL    = EXP(LOG(VNUM/VSTOR)/VL)
              DO 260 II=1,L
                DD(I)  = VSTOR
                IF (IT.EQ.0) LD(I)  = VSTOR
                I      = I+1
                IF (IT.EQ.2) THEN
                  DD(I)  = VSLOW
                  I      = I+1
                END IF
                VSTOR  = DEL*VSTOR
  260           CONTINUE
            END IF
            GO TO 110
          ELSE IF (C.EQ.HI) THEN
C     LINEAR INTERPOLATION
            L      = IN+1
            VL     = L
            VSTOR  = VNUM
            VNUM   = DREAD(IZ,IRET)
            C      = AREAD(M1,IARD)
            IF (C.NE.BB .AND. C.NE.CM) THEN
              IN     = VNUM
              VNUM   = DREAD(IZ,IRET)
            END IF
            IF (I+L*MULT.GT.LLIM) THEN
              WRITE(OUTPT,10500) HI,IN
              LERR   = .TRUE.
            ELSE
              DEL    = (VNUM-VSTOR)/VL
              IF (IT.EQ.0) THEN
                 IF (ANINT(DEL*VL).EQ.(VNUM-VSTOR)) DEL=1.00001*DEL
              END IF
              IF (ABS(ANINT(DEL)-DEL).LT.0.001) DEL = ANINT(DEL)
              DO 240 II=1,L
                DD(I)  = VSTOR
                IF (IT.EQ.0) LD(I)  = VSTOR
                I      = I+1
                IF (IT.EQ.2) THEN
                  DD(I)  = VSLOW
                  I      = I+1
                END IF
                VSTOR  = VSTOR + DEL
  240           CONTINUE
            END IF
            GO TO 110
          END IF
        END IF
      END IF
      IF (C.NE.TT) GO TO 100
  270 CONTINUE
      LSCAN  = LSAVE
      LALLC  = LSALL
      RETURN
10000 FORMAT('0***** ERROR - ATTEMPT TO STORE PAST THE END OF THE ',
     *       'ARRAY IN YREAD *****')
10100 FORMAT('0***** ERROR - A SKIP OF ',I5,' INCREMENTS THE ARRAY ',
     *       'INDEX TO ',I5,' WHICH IS OUTSIDE THE ARRAY IN YREAD ',
     *       '*****')
10200 FORMAT('0***** ERROR - AN ADDRESS OF ',I5,' IS OUTSIDE THE ',
     *       'ARRAY IN YREAD *****')
10300 FORMAT('0***** ERROR - A ',A,' SEQUENCE REPEAT OF ',I5,
     *       ' ITEMS STARTING FROM AN ARRAY INDEX OF ',I5,
     *       ' WITH A BACKSPACE OF ',I5/14X,
     *       ' STARTS BEFORE THE BEGINNING OF THE ARRAY IN YREAD *****')
10400 FORMAT('0***** ERROR - A ',A,' SEQUENCE REPEAT OF ',I5,
     *       ' ITEMS STARTING FROM AN ARRAY INDEX OF ',I5,
     *       ' WITH A BACKSPACE OF ',I5/14X,' REPEATED ',I5,' TIMES',
     *       ' WILL STORE PAST THE END OF THE ARRAY IN YREAD *****')
10500 FORMAT('0***** ERROR - INTERPOLATION TYPE ',A,
     *       ' SPECIFYING ',I5,' ENTRIES',
     *       ' WILL STORE PAST THE END OF THE ARRAY IN YREAD *****')
      END
