      SUBROUTINE CALI(NL,NLU,XA,DC,IP,NCMAX,NI4,
     1 NBOD,NCN,NBA,FPD,MA,LOCREG,D,LD)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     92/06/22
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     08:43:28
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MACALI
C     CURRENT ARCHIVING LEVEL NUMBER:                   00001
C     CURRENT NUMBER OF PERMANENT UPDATES:              00001
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/03/15
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C * * THIS ROUTINE DETERMINES PARTICLE LOCATION . IT FINDS UNIVERSE
C       , ARRAY AND COMBINATORIAL INPUT ZONE NUMBER PARTICLE IS IN.
      IMPLICIT REAL*8 (A-H,O-Z)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      COMMON/FLAG/IERROR
CTAT
      REAL*4 D
      COMMON/ARAR/NBY,NLEV,NAR,NQ,IAW,IAY,NF,NX1(3)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
      REAL*8 XB,WB,WP,XP,RIN,ROUT,PINF,DIST
      COMMON/PAREM/XB(3),WB(3),WP(3),XP(3),RIN,ROUT,PINF,DIST,IR,IDBG ,
     1             IRPRIM,NASC,LSURF,NBO,LRI,LRO,KLOOP,LOOP,ITYPE,NOA
      COMMON/ARK/NGY,NLL,NBB,NZY(3),XD(3)
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      DIMENSION MA(*),FPD(*),XA(3),IP(*),NCMAX(*),DC(3),
     1 NI4(*),NBOD(*),NCN(*),NBA(*),D(*),LD(*),   LOCREG(*)
      IPS=0
   5  CONTINUE
      IDB=IDBG
      DO 10 I=1,3
      WB(I) = DC(I)
  10  XB(I)=7777777.
  12  CONTINUE
      CALL LOOKZ(XA(1),XA(2),XA(3),D,MA,FPD,D(KLCR),D(KNBD),
     1 D(KIOR),D(KNSR))
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      IF(IRPRIM.LE.0) RETURN
      NMED=LD(KMIZ+IRPRIM-1)
      IF(IDB.EQ.0) GO TO 750
      WRITE(IOT,711) NL,NLU,IR,IRPRIM,NMED,NLEV
      CALL DIPR(D,IP,-1)
 711  FORMAT(5X,'CALI NL,NLU,IR,IRPRIM,NMED,NLEV',10I5)
 750  CONTINUE
      IF(NMED.GE.0) RETURN
C * * RETURN TO CALLING PROGRAM IF NOT IN ARRAY * *
      IF(NLEV.LE.0) RETURN
      IF(NMED.EQ.-1000) GO TO 40
C * * NMED=-1000 MEANS PARTICLE EXITING ARRAY * * *
      NLU=IABS(NMED)
      IA=LOCREG(IR)
      NBY=MA(IA+1)
      II=IP(NQ+11)
      NBU=NBY
      CALL TRENTE(XA,MA,FPD,D,LD,IP,NQ,NBA,NBY)
  15  NL=NL+1
      NLO=+1
      M=NI4(NLU)
      IGX=0
      CALL CELL(XA,MA,FPD,NLU,NCMAX,NI4,D(M),NBOD,NCN,D,LD,NX1,
     1 LU,LM,IER,LZ)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      II=IP(NQ+11)
      CALL STORA(D,LD,LM,LD(II),NL,NLU,NX1,IP,NBU)
CTAT  FORTRAN STOP STATEMENT KILLS PROCESS THAT STARTED FROM C MAIN.
CTAT  SO TO AVOID SUDDEN DETH, THIS FLAG IERROR ADDED.
      IF(IERROR.NE.0) RETURN
CTAT
      NLL=NLU
      NBB=NBY
      DO 22 MM=1,3
      NZY(MM)=NX1(MM)
      XD(MM)=XA(MM)
  22  CONTINUE
      IF(LZ+IER.EQ.0) GO TO 21
      IPS=0
      WRITE(IOT,23) LZ,LU,IER
  23  FORMAT(/,5X,' ERROR IN CALI FROM CELL * LZ=',I5,' LU=',I5,
     1 ' IER=', I5)
      GO TO 60
  21  CONTINUE
      L1=-1
      IF(IDB.EQ.1) CALL DIPR(D,IP,L1)
      N=3*(NLU-1)+1
      NR=NCN(N)
      NX=-1
      CALL CTRAN(XA,NCMAX(N),NX1,NX,NCN(N),D(NR),D,LD,IER)
      IF(LM) 25,40,30
  25  CONTINUE
      NLU=IABS(LM)
      GO TO 15
  30  CONTINUE
      NLO=0
      LL=LM
      NBY=NBOD(LM)
CST 2000/06/22
      NBY=NBDNO(NBY,MA)
CST 2000/06/22
      CALL RTEXIT(XA,MA,FPD,D,LD,IP,NQ,NBA,NBY)
      GO TO 12
  40  CONTINUE
      DO 50 I=1,3
      XA(I)=XA(I)-(1.0E-04)*WB(I)
  50  CONTINUE
      IPS=IPS+1
      IF(IPS.LE.1) GO TO 5
  60  CONTINUE
      WRITE(IOT,600) NMED,IPS,LZ,IER,LU,IR,IRPRIM,LM,LL,NL
 600  FORMAT(5X,'ERROR IN CALI * NMED,IPS,LZ,IER,LU,IR,IRPRIM,LM',
     1 ',LL,NL',10I5)
      IDBG=0
      CALL PR(D,1)
      CALL ABEND(LD)
      RETURN
      END
