      SUBROUTINE FFREAD(IN,K,V,NF,N5,N6,IPRTRG)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     93/02/24
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     07:25:53
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7FFREAD
C     CURRENT ARCHIVING LEVEL NUMBER:                   00015
C     CURRENT NUMBER OF PERMANENT UPDATES:              00015
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/02/24
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C
C****** FREE- AND FIXED-FIELD CARD IMAGE TRANSLATOR
C
C   *** NCPW IS THE CHARACTERS PER WORD
CLNG
C     PARAMETER(NCPW=8)
CLNG
CSHR
      PARAMETER(NCPW=4)
CSHR
CST
C     DIMENSION NY(80),IN(2),K(2),V(2)
      DIMENSION NY(80),IN(*),K(*),V(*)
      DIMENSION NUMB(10)
      CHARACTER*1 NUMB,NT,NBB,NDP,NPL,NPA,NMI,NSS,NDL,NS,NE,NQ,NM,NN
      CHARACTER*1 NR,NI,NFF,NA,NL,NK,NSLS,NCOM,NSL,NDB,NH,K,NY,NYNCC
      CHARACTER*8 BLANK,BUFFER
C
C ***** DOUBLE PRECISION FOR IBM 360
C
      DOUBLE PRECISION V,DNUM,VNUM,SGN,DUM,ONE,TEN
      DATA ONE/1.0D0/,TEN/10.0D0/
C
C ***** END OF DOUBLE PRECISION FOR IBM 360
C
      DATA NUMB/'0','1','2','3','4','5','6','7','8','9'/
      DATA NT,NBB,NDP,NPL,NPA,NMI/'T',' ','.','+','&','-'/
      DATA NSS,NDL,NS,NE/'S','$','*','E'/
      DATA NQ,NM,NN/'Q','M','N'/
      DATA NR,NI,NFF,NA,NL,NK/'R','I','F','A','L','K'/
      DATA NSLS,NCOM,NSL,IFREE/'/',',','''',0/
      DATA NDB/'#'/,NH/'H'/,BLANK/'        '/
  100 DO 110 I=1,37
         IN(I)  = 0
         V(I)   = 0.0
  110    K(I)   = NBB
      IEXP   = 0
      NSCL   = 0
      NDPN   = 0
      IEX    = 0
      VNUM   = 0.0
      SGN    = ONE
      IBLNK  = 0
      NF     = 1
      NCC    = 1
      IFC    = 0
      IDS    = 0
      NMAN   = 0
  120 READ(N5,10100) NY
      CALL Y0TRNS ( NY, 80 )
      IF (IPRTRG.GT.0)                             WRITE(N6,10000) NY
      IF (NY(1).NE.NSL)                            GO TO 130
      WRITE(N6,10100) NBB,(NY(I),I=2,80)
      GO TO 120
  130 NYNCC  = NY(NCC)
      IF (NYNCC.EQ.NCOM)                           NYNCC  = NBB
      IF (IFREE.EQ.0)                              GO TO 140
      IFC    = IFC+1
      IF (IFC.GT.12)                               IFC    = 1
      IF (IFC.EQ.3)                                GO TO 150
      IF (IFC.EQ.11.AND.IEX.NE.0.AND.NYNCC.EQ.NBB) GO TO 320
      IF (NYNCC.EQ.NE.AND.IFC.GT.4)                GO TO 240
  140 IF (NYNCC.EQ.NBB)                            GO TO 280
      IF (NYNCC.EQ.NPL.OR.NYNCC.EQ.NPA)            GO TO 230
      IF (NYNCC.EQ.NMI)                            GO TO 250
      IF (NYNCC.EQ.NE.AND.IBLNK.EQ.1)              GO TO 240
      IBLNK  = 1
      IF (NYNCC.EQ.NDP)                            GO TO 200
  150 DO 160 NUM=1,10
         IF (NUMB(NUM).EQ.NYNCC)                   GO TO 190
  160    CONTINUE
  170 IF (K(NF).NE.NBB.AND.NYNCC.EQ.NBB)           GO TO 280
      K(NF)  = NYNCC
      IN(NF) = SGN*VNUM
      VNUM   = 0.0
      SGN    = ONE
      IBLNK  = 0
      NMAN   = 0
      IF (NYNCC.EQ.NBB)                            GO TO 320
      IF (K(NF).NE.NDL.AND.K(NF).NE.NS.AND.K(NF).NE.NDB) GO TO 180
      NDBL   = 1
CSHR
      IF (K(NF).EQ.NDB)                            NDBL   = 2
CSHR
      IFREE  = 0
      IDS    = 1
      IF (NF.EQ.1)                                 GO TO 300
      IF (K(NF).NE.K(NF-1))                        GO TO 300
      IDS    = 0
      K(NF)  = NBB
      GO TO 320
  180 CONTINUE
      IF (NYNCC.EQ.NH)                             GO TO 340
      IF ( IFREE.EQ.0  .AND. NYNCC.NE.NSLS .AND. NYNCC.NE.NR .AND.
     *     NYNCC.NE.NI .AND. NYNCC.NE.NFF  .AND. NYNCC.NE.NA .AND.
     *     NYNCC.NE.NL .AND. NYNCC.NE.NK   .AND. NYNCC.NE.NQ .AND.
     *     NYNCC.NE.NM .AND. NYNCC.NE.NN )         GO TO 300
      IF ( IFREE.EQ.1  .AND. NYNCC.EQ.NSS )        GO TO 300
      IF (NCC.EQ.72)                               WRITE(N6,10200) NY
      GO TO 320
  190 CONTINUE
      IF (IEX.NE.0)                                GO TO 210
      DNUM   = NUM-1
      VNUM   = TEN*VNUM + DNUM
      NSCL   = NSCL + NDPN
      NMAN   = NMAN + 1
      GO TO 220
  200 NDPN   = -1
      GO TO 220
  210 CONTINUE
      IEXP   = IEXP*10 + IEX*(NUM-1)
  220 IF (IFC.EQ.12)                               GO TO 290
      GO TO 320
  230 IF (NMAN.GT.0)                               GO TO 240
      SGN    = ONE
      GO TO 320
  240 IEX    = 1
      GO TO 320
  250 IF (NMAN.GT.0)                               GO TO 260
      SGN    = -ONE
      GO TO 320
  260 IEX    = -1
      GO TO 320
  270 IFREE  = 1
      IDS    = 0
      GO TO 310
  280 IF (IDS.EQ.1)                                GO TO 270
      IF (IFREE.EQ.1 .AND. IFC.EQ.12 .AND. K(NF).NE.NBB) GO TO 290
      IF (IBLNK.EQ.0)                              GO TO 320
      IF (IFREE.EQ.1 .AND. IFC.NE.12)              GO TO 320
  290 VNUM   = SGN*VNUM
      DUM    = TEN**IABS(IEXP+NSCL)
      IF (IEXP+NSCL.GE.0)                   V(NF)  = VNUM*DUM
      IF (IEXP+NSCL.LT.0)                   V(NF)  = VNUM/DUM
      NMAN   = 0
  295 NDPN   = 0
      IEX    = 0
      IEXP   = 0
      NSCL   = 0
      IBLNK  = 0
      VNUM   = 0.0
      SGN    = ONE
  300 NF     = NF + 1
      IF (NYNCC.EQ.NSS)                            GO TO 320
  310 IFC    = 0
      IF (IFREE.EQ.1)                       NCC    = ((NCC+11)/12)*12
      IF (K(NF-1).EQ.NT)                           GO TO 330
  320 IF (NCC.GE.73)                               GO TO 330
      NCC    = NCC+1
      IF (NCC.LE.72)                               GO TO 130
      GO TO 280
  330 NF     = NF-1
      IF (NF.LE.0)                                 GO TO 100
      RETURN
  340 CONTINUE
      NHOL   = MIN0(IN(NF),72-NCC)
      IF (NHOL.NE.IN(NF)) WRITE(N6,10200) NY
      IN(NF) = NHOL
      IF (NHOL.LE.0)                               GO TO 295
      NCCMAX = NCC + NHOL
      KCPW   = NDBL*NCPW
      NWDS   = (NHOL+KCPW-1)/KCPW
      DO 370 KH=1,NWDS
         BUFFER = BLANK
         DO 350 KC=1,KCPW
            NCC    = NCC+1
            IF (NCC.GT.NCCMAX)                     GO TO 360
            NYNCC  = NY(NCC)
            CALL FFPACK ( BUFFER,NYNCC,KC )
  350       CONTINUE
  360    CONTINUE
         READ(BUFFER,10300) VNUM
         K(NF)  = NH
         V(NF)  = VNUM
         NYNCC  = NY(NCC)
         IF (NCC.GT.NCCMAX)                        GO TO 295
         NF     = NF+1
  370    CONTINUE
      NF     = NF-1
      GO TO 295
10000 FORMAT(' ',T53,80A1)
10100 FORMAT(80A1)
10200 FORMAT('0 ****** INCOMPLETE FIELD AT END OF CARD,',
     * ' SOME DATA MAY BE LOST'/'         CARD IMAGE FOLLOWS'/1X,80A1)
10300 FORMAT(A8)
      END
