      SUBROUTINE FIDAS (D,LD,LLD,LL2,J3,N5,N6)
C     EXTERNAL FIDCOM
C
C   *** DATA ARRAY MODIFICATION
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     97/06/13
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     09:25:56
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7FIDAS
C     CURRENT ARCHIVING LEVEL NUMBER:                   00021
C     CURRENT NUMBER OF PERMANENT UPDATES:              00021
C     DATE OF LAST ACCESS BY LIBRARIAN:                 97/06/13
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
CST 2000/06/23
CST   DIMENSION IN(37),K(37),V(37),LD(*),VMT(18),W(12),
      DIMENSION IN(37),K(37),V(37),LD(*),VMT(18),
     *          D(*),LLD(*)
      COMMON /FIDASC/ IPRTRG
      DIMENSION PRT(3)
      EQUIVALENCE (BB,LBB)
      DIMENSION VS(74)
      EQUIVALENCE (V(1),VS(1))
      DOUBLE PRECISION V,VV,VU,DEL,DELT,DIF,DL
      CHARACTER*1 K,LBB,LDL,LS,LR1,LI,LT,LSS,LF,LA,LAP,LPL,LMI,LZ,LV,LU
      CHARACTER*1 BB,LQ,LM,LN,LE,LLI,LKI,LO,LC,LSLS,LDB,LHL,LB
      CHARACTER*4 PRT,VMT
      DIMENSION DV(2),VI(2)
      EQUIVALENCE (DV(1),DELT),(VI(1),VV)
      DATA LDL,LS,LR1,LI,LT,LSS/'$','*','R','I','T','S'/
      DATA LF,LA,LAP,LPL,LMI/'F','A','&','+','-'/
      DATA LZ,LV,LU,BB/'Z','V','U',' '/
      DATA LQ,LM,LN/'Q','M','N'/,LE/'E'/,LLI/'L'/
      DATA LKI/'K'/
      DATA LO,LC,PRT(1),PRT(2),PRT(3)/'O','C','OFF ','PRT ','ON  '/
      DATA LSLS /'/'/
      DATA LDB/'#'/, LHL/'H'/
      KDBL   = 0
      LDBL   = 0
      J      = 0
      J3     = 0
      III    = 0
      IVMT   = 0
      NCOUNT = 0
  100 CALL FFREAD(IN,K,V,NF,N5,N6,IPRTRG)
      DO 120 I=1,NF
         IF (K(I).NE.LPL.AND.K(I).NE.LAP.AND.K(I).NE.LMI) GO TO 120
C   *** EXPONENTIATION (&,+,-)
         L      = IN(I)
         IF (L.EQ.0) GO TO 120
         E      = 10.0**L
         IF (K(I).EQ.LMI) GO TO 110
         V(I)   = V(I)*E
         GO TO 120
  110    V(I)   = V(I)/E
  120    CONTINUE
      I      = 1
  130 CONTINUE
         IF (III.EQ.0)                 GO TO 140
         IF (III-2) 570,510,540
  140    III    = 0
         IF (K(I).EQ.LBB)              GO TO 370
         IF (K(I).EQ.LHL)              GO TO 370
         IF (K(I).EQ.LDL)              GO TO 200
         IF (K(I).EQ.LS)               GO TO 190
         IF (K(I).EQ.LDB)              GO TO 180
         IF (K(I).EQ.LR1)              GO TO 400
         IF (K(I).EQ.LI)               GO TO 560
         IF (K(I).EQ.LT)               GO TO 150
         IF (K(I).EQ.LSS)              GO TO 340
         IF (K(I).EQ.LF)               GO TO 290
         IF (K(I).EQ.LA)               GO TO 330
         IF (K(I).EQ.LZ)               GO TO 390
         IF (K(I).EQ.LE)               GO TO 320
         IF (K(I).EQ.LQ)               GO TO 420
         IF (K(I).EQ.LM.OR.K(I).EQ.LN) GO TO 460
         IF (K(I).EQ.LU)               GO TO 160
         IF (K(I).EQ.LV)               GO TO 170
         IF (K(I).EQ.LLI)              GO TO 500
         IF (K(I).EQ.LKI)              GO TO 530
         IF (K(I).EQ.LO)               GO TO 350
         IF (K(I).EQ.LC)               GO TO 360
         IF (K(I).EQ.LSLS)             GO TO 210
         GO TO 370
C   *** TERMINATE (T)
  150    J2     = 0
         ITEST  = IN(I)
         KDBL   = LDBL
         IF (J.EQ.0) GO TO 250
         GO TO 220
C   *** VARIABLE FORMAT CONTROL (U,V)
  160    READ(N5,10900)VMT
  170    IVMT   = 1
         GO TO 190
C    *** BEGIN NEW ARRAY (*,$,#)
  180    KDBL   = LDBL
CSHR
         LDBL   = 1
CSHR
CLNG
C        LDBL   = 0
CLNG
         KKK    = 0
         GO TO 210
  190    KKK    = 0
         KDBL   = LDBL
         LDBL   = 0
         GO TO 210
  200    KKK    = 1
         KDBL   = LDBL
         LDBL   = 0
  210    IF (NCOUNT+J.EQ.0) GO TO 270
         J2     = 1
  220    IJ     = J
         IC     = NCOUNT
         INC    = 1
         IF (KDBL.EQ.0) GO TO 230
         IJ     = J/2
         IC     = NCOUNT/2
         INC    = 2
  230    WRITE(N6,10400) LL,LB,IJ
         IF (J.EQ.NCOUNT) GO TO 250
         IMAX   = J1 + J - 1
         IF (J.GT.10000) IMAX   = J + 99
         IF (KK.EQ.1) THEN
           WRITE(N6,'(1X,10I12)')      (LD(II),II=J1,IMAX,INC)
         ELSE
           WRITE(N6,'(1X,1P,10E12.5)') (D(II),II=J1,IMAX,INC)
         END IF
         J3     = J3 + 1
         WRITE(N6,10500) IC,LL,LB
  250    IF (J2.NE.0) GO TO 270
         WRITE(N6,10600)IN(I),LT
  260    RETURN
  270    IF (K(I).EQ.LSLS) GO TO 590
         LL     = IN(I)
         LL3    = LL + LL2 - 1
         KK     = KKK
         LB     = K(I)
         INC    = LDBL+1
         J      = INC*V(I)
         J1     = LLD(LL3) + J
         NCOUNT = LLD(LL3+ 1) - J1
         J      = 0
         IF (IVMT.EQ.0) GO TO 600
C   *** VARIABLE FORMAT CONTROL (U,V)
  280    IF (NCOUNT.EQ.0) GO TO 100
         J      = NCOUNT
         NCC    = J1 + NCOUNT - 1
         READ(N5,VMT) (D(J2),J2=J1,NCC)
         IVMT   = 0
         GO TO 100
C   *** FILL ARRAY (F)
  290    IF (J.GE.NCOUNT) GO TO 310
         NCC    = J+1
         DO 300 II=NCC,NCOUNT,INC
            J2     = J1 + II -1
            IF (LDBL.EQ.1) THEN
              D(J2)   = VS(2*I-1)
              D(J2+1) = VS(2*I)
            ELSE
              D(J2)   = V(I)
            END IF
            IF (KK.NE.0)  LD(J2) = V(I)
  300       CONTINUE
         J      = NCOUNT
         GO TO 600
  310    WRITE(N6,10700) LL,LB
         GO TO 600
C   *** END ARRAY (E)
  320    IF (J.LE.NCOUNT) J=NCOUNT
         GO TO 600
C   *** ADDRESS MODIFICATION (A)
  330    J      = V(I)
         IF (J.GT.NCOUNT.OR.J.LE.0) WRITE(N6,10800)J,LL,LB
         J      = INC*(J-1)
         GO TO 600
C   *** SKIP (S)
  340    J      = J + INC*IN(I)
         GO TO 600
C   *** TURN PRINT TRIGGER ON/OFF
  350    IPRTRG = -IPRTRG
         WRITE(N6,10100)PRT(2),PRT(IPRTRG+2),IN(I),LO
         GO TO 600
C   *** PRINT COUNT IN CURRENT ARRAY
  360    WRITE(N6,10200)LL,LB,J,IN(I),LC
         GO TO 600
C   *** NO MODIFICATION
  370    CONTINUE
  380    J2     = J1 + J
         J      = J+INC
         IF (LDBL.EQ.1) THEN
           D(J2)   = VS(2*I-1)
           D(J2+1) = VS(2*I)
         ELSE
           IF (K(I).EQ.LHL) THEN
             D(J2)   = VS(2*I-1)
             GO TO 600
           ELSE
             D(J2)   = V(I)
           END IF
         END IF
         IF (KK.NE.0) LD(J2) = V(I)
         GO TO 600
C   *** ZERO (Z)
  390    IN(I)  = V(I) + IN(I)
         V(I)   = 0.0
C   *** REPEAT (R)
  400    L      = IN(I)
CST      DO 410 II=1,MAX(1,L)
         DO 410 II=1,MAX0(1,L)
            J2     = J1 + J
            IF (LDBL.EQ.1) THEN
              D(J2)   = VS(2*I-1)
              D(J2+1) = VS(2*I)
            ELSE
              D(J2)   = V(I)
            END IF
            IF (KK.NE.0)  LD(J2) = V(I)
  410       J      = J+INC
         GO TO 600
C   *** SEQUENCE REPEAT (Q)
  420    L      = V(I) + IN(I)
         LSEQ   = 1
         IF (V(I).EQ.0.0.OR.IN(I).EQ.0) GO TO 430
         L      = V(I)
         LSEQ   = IN(I)
  430    DO 450 LSQ=1,LSEQ
            DO 440 II=1,L
               J2     = J1 + J
               J4     = J2 - L*INC
               D(J2)  = D(J4)
               IF (LDBL.EQ.1) D(J2+1) = D(J4+1)
  440          J      = J+INC
  450       CONTINUE
         GO TO 600
C   *** INVERTED SEQUENCE REPEAT (N)
  460    L      = V(I) + IN(I)
         LSEQ   = 1
         IF (V(I).EQ.0.0.OR.IN(I).EQ.0) GO TO 470
         L      = V(I)
         LSEQ   = IN(I)
  470    DO 490 LSQ=1,LSEQ
            DO 480 II=1,L
               J2     = J1 + J
               J4     = J2 - 2*II*INC + INC
C   *** REVERSED SIGN INVERTED SEQUENCE REPEAT (M)
               IF (LDBL.EQ.1)  THEN
                 VI(1) = D(J4)
                 VI(2) = D(J4+1)
               ELSE
                 VV     = D(J4)
               END IF
               IF (K(I).EQ.LM)     VV = -VV
               IF (LDBL.EQ.1) THEN
                 D(J2)   = VI(1)
                 D(J2+1) = VI(2)
               ELSE
                 D(J2)  = VV
               END IF
  480          J      = J+INC
  490       CONTINUE
         GO TO 600
C   *** LOGARITHMIC INTERPOLATION (L)
  500    L      = IN(I) + 1
         VV     = V(I)
         III    = 2
         GO TO 600
  510    VU     = V(I)/VV
CHANGED BY ST 96/12/18 FOR LAHEY FORTRAN
C        DL     = L
C        DEL    = EXP(LOG(VU)/DL)
         DL     = DBLE(L)
         DEL    = DEXP(DLOG(VU)/DL)
         J2     = J1 + J
         IF (LDBL.EQ.1) THEN
           D(J2)   = VI(1)
           D(J2+1) = VI(2)
         ELSE
           D(J2)   = VV
         END IF
         J      = J+INC
         DO 520 II=2,L
            J2     = J1 + J
            VV     = DEL*VV
            IF (LDBL.EQ.1) THEN
              D(J2)   = VI(1)
              D(J2+1) = VI(2)
            ELSE
              D(J2)  = VV
            END IF
  520       J      = J+INC
         IF (III.NE.0) GO TO 140
         GO TO 600
C   *** FIXED 10 LOG INTERP.  (K)
  530    L      = IN(I) + 1
         VV     = V(I)
         III    = 3
         GO TO 600
  540    DIF    = (V(I)-VV)/9.0D0
CHANGED BY ST 96/12/18 FOR LAHEY FORTRAN
C        DL     = L
C        DEL    = EXP(2.302585092994045D0/DL)
         DL     = DBLE(L)
         DEL    = DEXP(2.302585092994045D0/DL)
         J2     = J1 + J
         IF (LDBL.EQ.1) THEN
           D(J2)   = VI(1)
           D(J2+1) = VI(2)
         ELSE
           D(J2)   = VV
         END IF
         VV     = VV-DIF
         J      = J+INC
         DO 550 II=2,L
            J2     = J1 + J
            DIF    = DIF*DEL
            DELT   = VV + DIF
            IF (LDBL.EQ.1) THEN
              D(J2)   = DV(1)
              D(J2+1) = DV(2)
            ELSE
              D(J2)   = DELT
            END IF
  550       J      = J+INC
         IF (III.NE.0) GO TO 140
         GO TO 600
C   *** INTERPOLATE (I)
  560    L      = IN(I) + 1
         VV     = V(I)
         III    = 1
         GO TO 600
  570    DEL    = (V(I)-VV)/FLOAT(L)
         DO 580 II=1,L
            J2     = J1 + J
            DELT   = DEL*FLOAT(II-1) + VV
            IF (LDBL.EQ.1) THEN
              D(J2)   = DV(1)
              D(J2+1) = DV(2)
            ELSE
              D(J2)   = DELT
            END IF
            IF (KK.NE.0)  LD(J2) = DELT + SIGN(0.5D0,DEL)
  580       J      = J+INC
         IF (III.NE.0) GO TO 140
         GO TO 600
C   *** READ ALPHANUMERIC
  590    LL     = IN(I)
         LL3    = LL+LL2-1
         J2     = 1
         J      = 0
         NCOUNT = 0
         MODE   = 0
         IF (V(I).EQ.0) MODE   = 1
         LSTART = V(MODE+I)
         LSTOP  = V(MODE+I+1)
         LSTAR  = LLD(LL3) + LSTART - 1
         LSTO   = LLD(LL3) + LSTOP - 1
         READ(N5,10900) (D(II),II=LSTAR,LSTO)
         WRITE(N6,10300)LL,LSTART,LSTOP
         I      = MODE+I+1
  600    CONTINUE
         I      = I+1
         IF ( I.LE.NF ) GO TO 130
      GO TO 100
C   *** FORMAT STATEMENTS
10000 FORMAT(6(I2,A1,F9.0),T5,2A4,5(4X,2A4))
10100 FORMAT(' ',T53,2A4,I7,A1)
10200 FORMAT(T90,I5,A1,' ARRAY',I7,' ENTRIES READ AT',I4,A1)
10300 FORMAT('0',I5,'/ ARRAY READ FROM',I5,' TO',I5)
10400 FORMAT(1H0,I5,A1,' ARRAY',I7,' ENTRIES READ')
10500 FORMAT('0****** ERROR ',I7,' ENTRIES REQUIRED IN ',I3,A1,' ARRAY'/
     *  '0 DATA EDIT CONTINUES' )
10600 FORMAT(1H0,I5,A1)
10700 FORMAT('0****** FILL OPTION IGNORED IN ',I2,A1,' ARRAY' )
10800 FORMAT('0****** WARNING  ADDRESS',I7,' IS BEYOND LIMITS OF',I3,A1,
     *  ' ARRAY')
10900 FORMAT(18A4)
      END
