      SUBROUTINE FINEFI(NCMAX,NI4,NBOD,NCN,WLH,MA,FPD,NUMBOD,LOCREG,
     1 KBZ,MCZ,D,LD,IP,IBOD,NUMR)
C * * THIS ROUTINE CHECKS ARRAY INPUT WITH COMB. GEOM. INPUT
C     TO BE SURE ARRAYS FIT SNUGLY * * * * *
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 D
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON/ARAR/NBY,NLEV,NAR,NQ,IAW,IAY,NF,NX1(3)
      DIMENSION NCMAX(*),NI4(*),NBOD(*),NCN(*),WLH(*),MA(*),FPD(*),
     1 NUMBOD(*),LOCREG(*),KBZ(*),MCZ(*),D(*),LD(*),IP(*)
      DATA EPS /1.0D-9/
      IFE=0
      DO 500 N=1,NAR
      ICL=0
      N2=3*(N-1)+1
      LY=NCN(N2)
      IF(LY.GT.0) GO TO 10
      WRITE(IOT,12) N
  12  FORMAT(//5X,'WARNING - IN FINEFI',
     1       ' NO REFERENCE WAS MADE TO ARRAY NO.',I5//)
      GO TO 500
  10  CONTINUE
      M=3*(N-1)
      MX=NCMAX(M+1)
      MY=NCMAX(M+2)
      MZ=NCMAX(M+3)
      NR=NI4(N)
      DO 400 K=1,MZ
      DO 400 J=1,MY
      DO 400 I=1,MX
      CALL CWIDTH(DDX,DDY,DDZ,D(LY),MX,MY,MZ,I,J,K)
      IX=MY*MX*(K-1)+MX*(J-1)+I
      LX=IX+NR-1
      LM=LD(LX)
      IF(LM) 20,400,200
  20  CONTINUE
      N1=IABS(LM)
      IF(N1.LE.NAR) GO TO 50
      WRITE(IOT,40) N,I,J,K,N1
  40  FORMAT(//10X,'IN FINEFI INVALID ARRAY REFERENCE IN ARRAY ',I5
     1,' POSITION ',3I5,' TO NONEXISTENT ARRAY ',I5)
      IFE=1
      GO TO 400
  50  CONTINUE
      ICL=1
      NU=3*(N1-1)
      DX=WLH(NU+1)
      DY=WLH(NU+2)
      DZ=WLH(NU+3)
      GO TO 300
 200  CONTINUE
      IF(LM.LE.IBOD) GO TO 210
      IFE=1
      WRITE(IOT,205) N,I,J,K,LM
 205  FORMAT( //10X,'FINEFI FATAL ERROR - ARRAY ',I5,' POSITION',3I5,
     1 ' REFERS TO AN INVALID OR UNDEFINED UNIVERSE',I5  //)
      GO TO 400
 210  CONTINUE
      ICL=1
      NBY=NBOD(LM)
CST 2000/06/22
      KB=NBDNO(NBY,MA)
      NBY=KB
CST 2000/06/22
      LOC=MA(7*NBY)+2
      ITYPE=MA(7*NBY-4)
      IF(ITYPE.EQ.7) GO TO 250
      IF(ITYPE.EQ.9) GO TO 240
      WRITE(IOT,220) N,I,J,K,LM,NBY
 220  FORMAT( //10X,'IN FINEFI ARRAY NO.',I5,' POSITION ',3I5,
     1 ' REFERS TO UNIVERSE ',I5/10X,' DEFINED BY BODY ',I5,
     2 ' WHICH IS NOT AN RPP OR BOX - FATAL ERROR - '  //)
      IFE=1
 240  CONTINUE
      DX=FPD(LOC+1)-FPD(LOC)
      DY=FPD(LOC+3)-FPD(LOC+2)
      DZ=FPD(LOC+5)-FPD(LOC+4)
      GO TO 300
 250  CONTINUE
      DX=DSQRT(FPD(LOC+3)**2+FPD(LOC+4)**2+FPD(LOC+5)**2)
      DY=DSQRT(FPD(LOC+6)**2+FPD(LOC+7)**2+FPD(LOC+8)**2)
      DZ=DSQRT(FPD(LOC+9)**2+FPD(LOC+10)**2+FPD(LOC+11)**2)
 300  CONTINUE
      IFF=0
      IF(DABS(DX-DDX).GT.EPS) IFF=1
      IF(DABS(DY-DDY).GT.EPS) IFF=1
      IF(DABS(DZ-DDZ).GT.EPS) IFF=1
      IF(IFF.EQ.0) GO TO 400
      IFE=1
      WRITE(IOT,444) N,I,J,K,LM,DX,DDX,DY,DDY,DZ,DDZ
 444  FORMAT( //10X,'FINEFI - FATAL ERROR IN ARRAY ',I5,
     1       ' ELEMENT POSITION ',3I5/20X,' CONTAINS UNIVERSE ',I5,
     2       ' MISFIT IN POSITION '/30X,1P,6E15.5  //)
 400  CONTINUE
      IF(ICL.EQ.1) GO TO 500
      WRITE(IOT,540) N
 540  FORMAT( //10X,'IN FINEFI ',
     1  ' ARRAY ',I5,' HAS NO VALID ELEMENTS -VERY FATAL')
      IFE=1
 500  CONTINUE
      IVL=0
      DO 700 L=1,NUMR
      IF(MCZ(L).GE.0) GO TO 700
      IF(MCZ(L).EQ.-1000) GO TO 700
      IF(KBZ(L).EQ.0) IVL=1
      MN=LOCREG(L)+1
      NBD=NUMBOD(L)
      IF(NBD.LE.1) GO TO 630
      WRITE(IOT,620) L,NBD,KBZ(L),MCZ(L)
 620  FORMAT(//10X,'FINEFI - CODE ZONE ',I5,'CONTAINS AN ARRAY BUT ',
     1       ' IS DEFINED WITH MORE THAN ONE BODY - WARNING',3I5/
     2       ' FIRST BODY WILL BE REFERENCE BODY'//)
 630  CONTINUE
      NBY=MA(MN)
      N=IABS(MCZ(L))
      IF(N.LE.NAR) GO TO 635
      IFE=1
      WRITE(IOT,633) L,N
 633  FORMAT(//10X,'FINEFI FATAL ERROR - CODE ZONE',I5,
     1       ' REFERENCES AN INVALID ARRAY',I5//)
      GO TO 700
 635  CONTINUE
      LOC=MA(7*NBY)+2
      ITYPE=MA(7*NBY-4)
      IF(ITYPE.EQ.7) GO TO 670
      IF(ITYPE.EQ.9) GO TO 650
      IFE=1
      WRITE(IOT,640) L,N,NBY
 640  FORMAT(//10X,
     1  'FINEFI  FATAL ERROR -CODE ZONE ',I5,' CONTAINS ARRAY',I5,
     2 ' INSIDE BODY',I5/10X,' REFERENCED BODY IS NOT AN RPP OR BOX')
      GO TO 700
 650  CONTINUE
      DX=FPD(LOC+1)-FPD(LOC)
      DY=FPD(LOC+3)-FPD(LOC+2)
      DZ=FPD(LOC+5)-FPD(LOC+4)
      GO TO 690
 670  CONTINUE
      DX=DSQRT(FPD(LOC+3)**2+FPD(LOC+4)**2+FPD(LOC+5)**2)
      DY=DSQRT(FPD(LOC+6)**2+FPD(LOC+7)**2+FPD(LOC+8)**2)
      DZ=DSQRT(FPD(LOC+9)**2+FPD(LOC+10)**2+FPD(LOC+11)**2)
 690  CONTINUE
      NU=3*(N-1)
      DDX=WLH(NU+1)
      DDY=WLH(NU+2)
      DDZ=WLH(NU+3)
      IFF=0
      IF(DABS(DX-DDX).GT.EPS) IFF=1
      IF(DABS(DY-DDY).GT.EPS) IFF=1
      IF(DABS(DZ-DDZ).GT.EPS) IFF=1
      IF(IFF.EQ.0) GO TO 700
      IFE=1
      WRITE(IOT,695) N,NBY,L,DX,DDX,DY,DDY,DZ,DDZ
 695  FORMAT( //10X,'FINEFI FATAL ERROR - ARRAY',I5,' IN BODY',I5,
     1' REFERENCED IN CODE ZONE',I5,' DOES NOT FIT'/5X,1P,6E20.10//)
      WRITE(IOT,777) (FPD(LOC+I-1),I=1,6),
     1 ((WLH(3*(II-1)+IJ),IJ=1,3),II=1,NAR)
 777  FORMAT(/5X,1P,6E20.10,99(/10X,1P,3E20.10))
 700  CONTINUE
      IF(IVL.EQ.1) GO TO 720
      IFE=1
      WRITE(IOT,740)
 740  FORMAT(//10X,'FINEFI FATAL ERROR - YOU HAVE AT LEAST ONE ',
     1 'ARRAY BUT NO ARRAY WAS REFERENCED IN A LEVEL ZERO ZONE '//)
 720  CONTINUE
      IF(IFE.EQ.0) GO TO 800
      CALL DIPR(D,IP,0)
      CALL PR(D,1)
      CALL ERRTRA
CHANGED BY ST 96/12/18
C     CALL EXIT
      RETURN
 800  CONTINUE
      RETURN
      END
