        SUBROUTINE JOMIN2(NSTOR,ISTR,NAAD)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     93/03/15
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     14:36:56
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MAJOMIN2
C     CURRENT ARCHIVING LEVEL NUMBER:                   00003
C     CURRENT NUMBER OF PERMANENT UPDATES:              00003
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/03/15
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C     JOMIN2 READS THE BINARY GEOM FILE FROM UNIT IOUT AND CALLS GENI
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*4 JTY1(15)
      COMMON/GOMLOC/ KMA,KFPD,KLCR,KNBD,KIOR,KRIZ,KRCZ,KMIZ,KMCZ,KKR1,
     1 KKR2,KNSR,KVOL,NADD,LDATA,LTMA,LFPD,NUMR,IRTRU,NUMB,NIR,KBIZ,KBCZ
      REAL*8 XB,WB,WP,XP,RIN,ROUT,PINF,DIST
      COMMON/PAREM/XB(3),WB(3),WP(3),XP(3),RIN,ROUT,PINF,DIST,IR,IDBG ,
     1             IRPRIM,NASC,LSURF,NBO,LRI,LRO,KLOOP,LOOP,ITYPE,NOA
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      DIMENSION NSTOR(*)
CSHR
      PARAMETER ( ISPCD = 2 )
CSHR
CLNG
C     PARAMETER ( ISPCD = 1 )
CLNG
      REWIND IOUT
      READ(IOUT)(JTY1(I),I=1,15)
      READ(IOUT)IVOPT,IDBG,IRTRU,NUMR,NUMB,LADD,NAZT,IBODT,LTMA,LFPD
      WRITE(IOT,25)(JTY1(I),I=1,15),IVOPT,IDBG
 25   FORMAT (1H1//10X,15A4//20X,7HIVOPT =,I2,10X,6HIDBG =,I2/)
      KMA=ISTR
   10 KFPD=KMA+LTMA
C.....FPD ARRAY MUST START ON DOUBLE PRECISION WORD BOUNDARY FOR IBM
      KFPD=2*(KFPD/2)+1
      KLCR=KFPD+ISPCD*LFPD
      KNBD=KLCR+NUMR
      KIOR=KNBD+NUMR
      KRIZ=KIOR+NUMR
      KRCZ=KRIZ+IRTRU
      KBIZ=KRCZ+NUMR
      KBCZ=KBIZ+IRTRU
      KMIZ=KBCZ+NUMR
      KMCZ=KMIZ+IRTRU
      KKR1=KMCZ+NUMR
      KKR2=KKR1+IRTRU
      KNSR=KKR2+IRTRU
      KVOL=KNSR+NUMR
      KVOL=2*(KVOL/2)+1
      KRF=KRCZ-1
      KMF=KMCZ-1
      KLF=KBCZ-1
C     TO READ REGION DATA
      NDX=KRIZ-1
      READ(IOUT)(NSTOR(NDX+J),J=1,IRTRU)
C ...READ GEOMETRY BOX-SPACE DATA      *************
      NDX=KBIZ-1
      READ(IOUT) (NSTOR(NDX+J),J=1,IRTRU)
C     TO READ MEDIA DATA
      NDX=KMIZ-1
      READ(IOUT)(NSTOR(NDX+J),J=1,IRTRU)
   40 FORMAT(1H0/10X,36HMORSE REGION IN INPUT ZONE(I) ARRAY ,
     1   14H (MRIZ(I),I=1,,I3,1H)//(10X,22I5/))
   50 FORMAT(1H0/10X,34HMORSE MEDIA IN INPUT ZONE(I) ARRAY,
     1   14H (MMIZ(I),I=1,,I3,1H)//(10X,22I5/))
   55 FORMAT(1H0/10X,37HMORSE UNIVERSE IN INPUT ZONE(I) ARRAY,
     1   14H (NBIZ(I),I=1,,I3,1H)//(10X,22I5/))
      CALL GENI(NSTOR(KMA),NSTOR(KFPD),            NSTOR(KLCR),
     1 NSTOR(KNBD),NSTOR(KIOR),NSTOR(KRIZ),NSTOR(KRCZ),NSTOR(KMIZ),
     2 NSTOR(KMCZ),NSTOR(KKR1),NSTOR(KKR2),NSTOR(KBIZ),NSTOR(KBCZ),
     3 INTT,IOT,IOUT,IBODT)
      WRITE(IOT,40) IRTRU, (NSTOR(I),I=KRIZ,KRF)
      WRITE(IOT,50) IRTRU,(NSTOR(I),I=KMIZ,KMF)
      WRITE(IOT,55) IRTRU,(NSTOR(I),I=KBIZ,KLF)
      NIR=1
      DO 70 I=2,IRTRU
      INDX=KRIZ-1+I
      IM1=I-1
      DO 60 J=1,IM1
      JNDX=KRIZ-1+J
      IF(NSTOR(JNDX).EQ.NSTOR(INDX)) GO TO 70
   60 CONTINUE
      NIR=NIR+1
   70 CONTINUE
      NAAD=KVOL+NIR*ISPCD-KMA
C    NADD IS SPACE USED BY CG IN JOMIN2  **** SHOULD BE  SAME AS JOMIN1
        NADD=NAAD
      DO 80 I=1,NUMR
      J=KNSR-1+I
   80 NSTOR(J)=0
      CALL GTVLIN(NSTOR(KFPD),NSTOR(KRIZ),NSTOR(KVOL),IVOPT,
     1   NIR,IRTRU,IOUT,IOT)
      RETURN
      END
