      SUBROUTINE SORT(XB,NCMAX,LU,RBY,NXY,D,LD,WB,M,IER,IFL)
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     92/06/22
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     09:04:15
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MASORT
C     CURRENT ARCHIVING LEVEL NUMBER:                   00002
C     CURRENT NUMBER OF PERMANENT UPDATES:              00002
C     DATE OF LAST ACCESS BY LIBRARIAN:                 93/03/15
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C *** THIS ROUTINE DETERMINES CELL POSITION ON EACH DIMENSION **
C *** ALSO, DETERMINES WHEN PARTICLE IS EXITING AN ARRAY LATTICE
C *******************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      COMMON /MGOMV/  MUS,MUZ,LL,IPRET,IFLOW,IECT,NLO,IGX
CST
      REAL*4 D
CST
      DIMENSION XB(3),WB(3),NCMAX(3),RBY(*),NXY(3),D(*),LD(*)
      DATA SML/1.0E-09/,OSML/1.0000055/
      NMAX=NCMAX(M)+1
      IFL=0
      I=0
      LX1=1
      LX2=NMAX
      SMALL= DMAX1(SML,SML*RBY(LX2))
      IF(XB(M).LE.-SMALL.OR.RBY(LX2)*OSML.LT.XB(M)) GO TO 20
      IF(IGX.EQ.0) GO TO 60
      LX1=NXY(M)-1
      IF(LX1) 20,50,55
  50  LX1=1
  55  LX2=NXY(M)+1
      IF(LX2-NMAX) 60,60,20
  60  CONTINUE
      SMALL= DMAX1(SML,SML*RBY(LX2))
      DO 10 I=LX1,LX2
      IF(RBY(I)-SMALL.GT.XB(M)) GO TO 15
      IF(RBY(I).GT.XB(M)-SMALL) GO TO 12
  10  CONTINUE
      I=LX2
      IF(IGX.EQ.1) GO TO 20
  12  CONTINUE
      LU=M
      NXY(M)=I-1
      IF(WB(M).GE.0.0) NXY(M)=I
      IF(DABS(WB(M)).GT.SML .AND.IGX.EQ.1) GO TO 18
      IF(NXY(M).EQ.0) NXY(M)=1
      IF(NXY(M).EQ.NMAX) NXY(M)=NMAX-1
      IF(NXY(M).NE.I) IFL=1
  18  CONTINUE
      XB(M)=RBY(I)
      RETURN
  15  NXY(M)=I-1
      RETURN
  20  CONTINUE
C *** PRINT ERROR MESSAGE - SET ERROR FLAG FOR PILOT         *****
      IER=1
      WRITE(IOT,668)
      WRITE(IOT,666) M,NMAX,IGX,LX1,LX2,NXY,XB,RBY(LX2 ),SML,SMALL
      CALL ABEND(LD)
CADDED BY ST 96/12/18
      RETURN
 668  FORMAT(//,5X,'FATAL ERROR IN SORT  *** PARTICLE LOST ON',
     1 ' ENTERING OR EXITING ARRAY.')
 666  FORMAT(//,' M,NMAX,IGX,LX1,LX2,NXY',3X,8I5,//,' XB,RBY(LX2),',
     1 'SML,SMALL',/,5X,1P,6E18.8/)
C  THE FOLLOWING STATMENTS NOT REACHABLE SINCE 4/92 ABEND KILLS JOB
C     IF(XB(M).GT.0.0) GO TO 30
C     NXY(M)=0
C     RETURN
C 30  NXY(M)=NMAX+1
C     RETURN
      END
